// Barb the browser -- file barb.cpp
// compiled with BCPP 4.51, using -mc switch for compact memory model
/*
 A Brief like File Browsing Program
 Copyright (C) 1995 KANSYS, Inc.
 This program is free software; you can redistribute it and/or 
 modify it under the terms of the GNU General Public License as 
 published by the Free Software Foundation; either version 2 of 
 the License, or (at your option) any later version.
 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 General Public License for more details.
 You should have received a copy of the GNU General Public License 
 along with this program; if not, write to the Free Software 
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 Author: Charles E. Hallenbeck, Ph.D.
 KanSys, Inc.
 4301 Wimbledon Terr. #2B
 Lawrence, KS 66047
 Telephone: 913-843-0351
*/
#include <fstream.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <bios.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
struct line { line *p, *n; char *t; };
struct history { char ft, fn[13]; int date, time; long size;
unsigned start; int x, y; };
struct point { int x, y; };
const int hst_size = 73; // entries in history file
void showlines (line *, int, int);
int linesize (line *, int);
int wordleft (line *, int, int);
int wordright (line *, int, int);
point location (char *, line *, int, int, int, int);
char *getbuf (char *);
char analyze (char *);
int get1line (char *, int, int);
int get2line (char *, int, int);
int get3line (char *, int);
int get4line (char *, int);
int get5line (char *, int);
int get6line (char *, int);
void savetext (line *, int, int, char *);
char wp5get (ifstream *);
char wp6get (ifstream *);
char ws7get (ifstream *);
char html8get (ifstream *);
void gethistory (char, char *, char *, history *);
void main (int argc, char **argv)
{ int a, b, c, n, nh1, nh2, w;
int anchor, more, fwd, caps, open;
point now, bookmark[10];
unsigned key, nl, nl1, nl2;
char ft, *s, buf[MAXPATH];
char hf[MAXPATH], fn[MAXPATH], ss[MAXPATH], wf[MAXPATH];
line *head, *tail, *next;
strcpy (hf, *argv); s=strrchr (hf, '.'); strcpy (s+1, "HST");
nl1=0; ft='?';
while (argv[1][0]=='-' || argv[1][0]=='/') // get options
{ argc--; argv++; if (tolower (argv[0][1])=='j') nl1=atoi (argv[0]+2);
else if (tolower (argv[0][1])=='f') ft=argv[0][2]; }
if (argc!=2) // incorrect usage
{ cout << "Usage: Barb [options] <filename>" << endl
 << "The options are:" << endl
 << "-F#  File type: 1=text, 2=binary, default=automatic." << endl
 << "-J###  Lines to Jump over at start of file, default=0." << endl;
return; }
strcpy (fn, *++argv);
if (ft=='?') ft=analyze (fn);
if (ft=='?') return; // if file type analysis failed
history *hst = new history [hst_size];
gethistory (ft, fn, hf, hst);
if (nl1) { hst[0].start=nl1; hst[0].x=1; hst[0].y=1; }
else nl1=hst[0].start;
open=1; while (open) { open=2; head = tail = NULL;
n=0; nl=nl1; nl2=0; caps=0;
switch (ft) { // initial file operations
case '1': case '8': more=get1line (fn, 0, ft=='8'); break;
case '2': case '7': more=get2line (fn, 0, ft=='7'); break;
case '3': more=get3line (fn, 0); break;
case '4': more=get4line (fn, 0); break;
case '5': more=get5line (fn, 0); break;
case '6': more=get6line (fn, 0); break;
default: more=0; break; }
if (!more) { cout << "Cannot open " << fn << endl; return; }
while (more) { switch (ft) { // read a line at a time
case '1': case '8': more=get1line (buf, MAXPATH, ft=='8'); break;
case '2': case '7': more=get2line (buf, MAXPATH, ft=='7'); break;
case '3': more=get3line (buf, MAXPATH); break;
case '4': more=get4line (buf, MAXPATH); break;
case '5': more=get5line (buf, MAXPATH); break;
case '6': more=get6line (buf, MAXPATH); break;
default: more=0; break; }
if (!more) break;
s = buf+strlen(buf); while (s!=buf) { if (*s>32) break; *s=0; s--; }
if (s==buf) continue; // ignore blank lines
if (nl) { nl--; continue; }
if (nl2 || coreleft() < 2048) { nl2++; continue; }
n++; next = new line; next->p = tail; next->n = NULL;
if (tail==NULL) head = next; else tail->n = next; tail = next;
next->t = new char [strlen(buf)+1]; strcpy (next->t, buf); }
clrscr (); directvideo=0;
cprintf ("Barb is browsing "); switch (ft) { // file type
case '1': cprintf ("TXT file"); break;
case '2': cprintf ("binary file"); break;
case '3': cprintf ("PS file"); break;
case '4': cprintf ("WRI file"); break;
case '5': cprintf ("WP5 file"); break;
case '6': cprintf ("WP6 file"); break;
case '7': cprintf ("WS file"); break;
case '8': cprintf ("HTML file"); break;
default: break; }
cprintf (" %s", fn);
if (nl1 || nl2) cprintf (" (%u/%u)", nl1, nl2);
if (nl1==hst[0].start) { c=hst[0].x; a=hst[0].y; }
else { c=1; a=1; }
for (b=1; a>20; a-=20) b+=20;
gotoxy (66, 1); cprintf ("C%d L%d/%d", c, a+b-1, n);
directvideo=1; gotoxy (1, 2); for (w=0; w<80; w++) putc (205, stdout);
gotoxy (1, 23); for (w=0; w<80; w++) putc (205, stdout);
gotoxy (8, 25); cprintf // command hints on bottom line
("F5=search; alt G=go to; alt digit, alt J digit=bookmark; alt X=exit.");
window (1, 3, 80, 22);
showlines (head, b, 1); gotoxy (c, a); nh1=nh2=anchor=0;
for (w=0; w<10; w++) { bookmark[w].x=0; bookmark[w].y=0; }
ss[0]=0; wf[0]=0;
while (open==2) { key=bioskey (0);
if (key==(71<<8) || key==(71<<8|224)) { nh1++; nh2=0; } // home
else if (key==(79<<8) || key==(79<<8|224)) { nh1=0; nh2++; } // end
else nh1=nh2=0;
switch (key) {
case 17<<8: // alt W -- write buffer to a file
window (1, 24, 80, 24); clrscr (); directvideo=0;
cprintf ("Write %s as: ", (anchor? "block": "text"));
strcpy (buf, wf); s=getbuf (buf); clrscr (); 
if (s==NULL) cprintf ("Command cancelled.");
else { strcpy (wf, buf); savetext (head, anchor, a+b-1, buf); }
anchor=0; directvideo=1; break;
case 34<<8: // alt G -- go to
window (1, 24, 80, 24); clrscr ();
directvideo=0; cprintf ("Go to line: ");
buf[0]=0; s=getbuf (buf); clrscr (); 
if (s==NULL) { cprintf ("Command cancelled."); directvideo=1; break; }
w=atoi (s); if (w<1) w=1; else if (w>n) w=n;
window (1, 3, 80, 22); directvideo=1;
showlines (head, b=w, 1); a=1; c=1; break;
case 36<<8: // alt J -- jump to bookmark
window (1, 24, 80, 24); clrscr ();
directvideo=0; cprintf ("Go to bookmark [1-10]: ");
buf[0]=0; s=getbuf (buf); clrscr (); 
if (s==NULL) { cprintf ("Command cancelled."); directvideo=1; break; }
w=atoi (s); if (w<1 || w>10) // not a valid bookmark
{ cprintf ("Invalid bookmark number."); directvideo=1; break; }
w--; if (bookmark[w].y<1 || bookmark[w].y>n) // not a valid bookmark
{ cprintf ("That bookmark doesn't exist."); directvideo=1; break; }
window (1, 3, 80, 22); directvideo=1;
showlines (head, b=bookmark[w].y, 1); a=1; c=bookmark[w].x; break;
case 38<<8: // alt L -- drop a line anchor
window (1, 24, 80, 24); clrscr (); directvideo=0;
cprintf ("Dropping a line anchor."); anchor = a+b-1;
directvideo=1; break;
case 45<<8: // alt X -- exit
open=0; break;
case 63<<8: // F5 -- search forward
case 88<<8: // shift F5 -- resume search
case 108<<8: // alt F5 -- search backward
window (1, 24, 80, 24); clrscr (); directvideo=0;
if (key!=(88<<8)) // new search
{ cprintf ("Search for: "); strcpy (buf, ss);
s=getbuf (buf); clrscr (); 
if (s==NULL) { cprintf ("Command cancelled."); directvideo=1; break; }
strcpy (ss, buf); }
if (!ss[0]) cprintf ("No previous search pattern.");
else { strcpy (buf, ss); if (caps) strlwr (buf);
if (key==(63<<8)) fwd=1; // forward
else if (key==(88<<8)) fwd|=2; // resume
else if (key==(108<<8)) fwd=0; // backward
now = location (buf, head, a+b-1, c-1, fwd, caps);
if (now.y) { cprintf ("Search completed.");
if (now.y<b || now.y>(b+19)) { window (1, 3, 80, 22);
directvideo=1; showlines (head, b=now.y, 1); a=1; }
else a=now.y-b+1; c=now.x; }
else cprintf ("Pattern not found."); }
directvideo=1; break;
case 71<<8: case 71<<8 | 224: // home
if (nh1==1) { c=1; break; }
if (nh1==2) { c=1; a=1; break; }
case 119<<8: case 119<<8 | 224: // control home
showlines (head, b=1, 1); c=1; a=1; break;
case 72<<8: case 72<<8 | 224: // up arrow
if ((a+b)==2) break;
if (a>1) a--; else showlines (head, --b, 0);
w=linesize (head, a+b-1); if (w<c) c=w; break;
case 73<<8: case 73<<8 | 224: // page up
if (b>20) b-=20; else b=1;
showlines (head, b, 1); c=1; a=1; break;
case 75<<8: case 75<<8 | 224: // left arrow
if (c>1) { c--; break; }
if ((a+b)==2) break;
if (a>1) a--; else showlines (head, --b, 0);
c=linesize (head, a+b-1); break;
case 77<<8: case 77<<8 | 224: // right arrow
if (c<linesize (head, a+b-1)) { c++; break; }
if (n==(a+b-1)) break;
if (a<20) a++; else showlines (head, ++b, 0); c=1; break;
case 79<<8: case 79<<8 | 224: // end
if (nh2==1) { c = linesize (head, a+b-1); break; }
if (nh2==2) { a = (n<(b+20)? n-b: 20);
c=linesize (head, a+b-1); break; }
case 117<<8: case 117<<8 | 224: // control end
showlines (head, b=n, 1); a=1;
c=linesize (head, a+b-1); break;
case 80<<8: case 80<<8 | 224: // down arrow
if (n==(a+b-1)) break;
if (a<20) a++; else showlines (head, ++b, 0); break;
case 81<<8: case 81<<8 | 224: // page down
case 28<<8 | 13: case 224<<8 | 13: // CR -- same as Page Down
if (b<(n-20)) b+=20; else b=n;
showlines (head, b, 1); c=1; a=1; break;
case 98<<8: // control F5 -- change case sensitivity
window (1, 24, 80, 24); clrscr (); directvideo=0;
if (caps^=1) cprintf ("Case sensitivity off.");
else cprintf ("Case sensitivity on."); directvideo=1; break;
case 115<<8: case 115<<8 | 224: // control left arrow
w=wordleft (head, a+b-1, c);
if (w) { c=w; break; }
if ((a+b)==2) break;
if (a>1) a--; else showlines (head, --b, 0);
c=wordleft (head, a+b-1, linesize (head, a+b-1));
if (!c) c=1; break;
case 116<<8: case 116<<8 | 224: // control right arrow
w=wordright (head, a+b-1, c);
if (w) { c=w; break; }
if (n==(a+b-1)) break;
if (a<20) a++; else showlines (head, ++b, 0);
w=wordright (head, a+b-1, 0);
if (w) c=w; break;
case 118<<8: case 118<<8 | 224: // control page down
case 28<<8 | 10: case 224<<8 | 10: // Control CR -- same as above
if (nl2) { nl1+=n; open=1; } 
else { window (1, 24, 80, 24); clrscr (); directvideo=0;
cprintf ("No more unread lines."); directvideo=1; } break;
case 120<<8: case 121<<8: case 122<<8: case 123<<8: case 124<<8:
case 125<<8: case 126<<8: case 127<<8: case 128<<8: case 129<<8:
window (1, 24, 80, 24); clrscr (); directvideo=0;
w = (key>>8)-120; if (bookmark[w].y) // duplicate
{ cprintf ("Overwrite existing bookmark [Y/N]? ");
if (tolower (getche ()) != 'y')
{ cprintf ("Command cancelled."); directvideo=1; break; } }
bookmark[w].x=c; bookmark[w].y = a+b-1; cprintf ("Bookmark dropped.");
directvideo=1; break;
case 132<<8: case 132<<8 | 224: // control page up
if (nl1) { nl1=0; open=1; }
else { window (1, 24, 80, 24); clrscr (); directvideo=0;
cprintf ("No jumped over lines."); directvideo=1; } break;
default: break; }
window (66, 1, 80, 1); clrscr ();
cprintf ("C%d L%d/%d", c, a+b-1, n);
window (1, 3, 80, 22); gotoxy (c, a); }
for (next=head; next!=NULL; head=next) // return to heap
{ next=next->n; delete head->t; delete head; }
window (1, 1, 80, 25); } clrscr ();
if (hst[0].start!=nl1 || hst[0].x!=c || hst[0].y!=a+b-1) // history
{ hst[0].start=nl1; hst[0].x=c; hst[0].y=a+b-1;
ofstream fout (hf, ios::binary);
if (fout.good()) fout.write ((char *) hst, hst_size*sizeof(history));
delete hst; } }
/***/void showlines (line *head, int b, int flag)
{ int a;
line *next;
for (next=head, a=1; a<b; a++) if (next!=NULL) next = next->n;
for (a=0; a<20; a++) { gotoxy (1, a+1);
if (next!=NULL)
{ directvideo = (flag? 0: 1);
cprintf ("%s", next->t); next=next->n; }
clreol (); } directvideo=1; }
/***/int linesize (line *p, int n)
{ while (--n) if (p!=NULL) p=p->n; else break;
return (p==NULL? 1: strlen (p->t)+1); }
/***/int wordleft (line *p, int n, int c)
{ if (c<2) return 0;
while (--n) if (p!=NULL) p=p->n; else break;
if (p==NULL) return 0;
if (isspace (p->t[c-2]) && !isspace (p->t[c-1])) c--; // get started
while (--c) if (isspace (p->t[c-1]) && !isspace (p->t[c])) return c+1;
return (isspace (p->t[c])? 0: 1); }
/***/int wordright (line *p, int n, int c)
{ int l;
while (--n) if (p!=NULL) p=p->n; else break;
if (p==NULL) return 0;
l = strlen (p->t)+1;
if (c) while (c<l && !isspace (p->t[c-1])) c++; // skip nonblanks
else c=1; while (c<l && isspace (p->t[c-1])) c++; // then skip blanks
return (c==l? 0: c); }
/***/point location (char *s1, line *p1, int n, int x, int fwd, int caps)
{ int l1=strlen(s1), l2;
char *s, s2[MAXPATH];
line *p2;
point now;
now.x=0; now.y=0;
if (l1<1 || n<1) return now;
p2=p1; while (--n) if (p2!=NULL) p2=p2->n; else return now;
if (fwd&1) // search forward
{ if (fwd&2) x++; // resume search
while (p2!=NULL) { strcpy (s2, p2->t); l2 = strlen (s2);
if (l2<(l1+x)) { x=0; p2=p2->n; continue; }
if (caps) strlwr (s2);
if ((s=strstr (s2+x, s1))!=NULL) break;
x=0; p2=p2->n; } }
else // search backward
{ if (fwd&2) x--; // resume search
while (p2!=NULL) { strcpy (s2, p2->t); l2 = strlen (s2);
if ((l1+x)<l2) { l2=l1+x; s2[l2]=0; }
if (l2<l1) { x=MAXPATH; p2=p2->p; continue; }
if (caps) strlwr (s2);
if (x==MAXPATH) x=l2 - l1;
while (x && (s=strstr (s2+x-1, s1))==NULL) x--;
if (s!=NULL) break;
x=MAXPATH; p2=p2->p; } }
if (p2==NULL) return now;
for (now.y=1; p1!=p2; now.y++) p1=p1->n;
for (now.x=1; s!=s2; now.x++) s--;
return now; }
/***/char *getbuf (char *buf)
{ int a=1, l1, l2=strlen(buf), x=wherex(), y=wherey();
unsigned k1, k2, key;
l1=l2; if (l1) cprintf ("%s", buf);
do { key=bioskey(0); k1=key>>8; k2=key%(1<<8); switch (k2) {
case 0: case 224: a=0; // edit the data
if (k1==75 && l1) --l1; // left arrow
else if (k1==77 && l1<l2) ++l1; // right arrow
else if (k1==71) l1=0; // home
else if (k1==79) l1=l2; // end
else if (k1==83 && l1<l2) // delete
{ --l2; strcpy (buf+l1, buf+l1+1); cprintf ("%s", buf+l1); clreol(); }
gotoxy (x+l1, y); break;
case 8: a=0; if (l1<1) break; // backspace
if (l1<l2) { --l1; strcpy (buf+l1, buf+l1+1);
gotoxy (x+l1, y); cprintf ("%s", buf+l1); clreol(); }
else { buf[--l1]=0; 
gotoxy (x+l1, y); putc (' ', stdout); }
gotoxy (x+l1, y); --l2;  break;
case 27: return NULL; // command cancelled
default: if (k2<32) break;
if (a) { buf[l2=l1=0]=0; gotoxy (x, y); clreol (); }
++l2; for (a=l2; a>l1; a--) buf[a]=buf[a-1]; buf[l1]=k2;
gotoxy (x+l1, y); cprintf ("%s", buf+l1); ++l1; a=0; break; } }
while (k2!=13); return buf; }
/***/char analyze (char *fn)
{ unsigned char c1, c2, c3, c4;
char ft='?';
ifstream fin (fn, ios::binary);
if (fin.fail()) { cout << "Cannot find " << fn << endl; return ft; }
ft='1'; // default
fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
if (c1==4 && c2=='%' && c3=='!' && c4=='P') // probably PS
{ c1=c2; c2=c3; c3=c4; fin.get(c4); }
if (c1=='%' && c2=='!' && c3=='P' && c4=='S') // probably PS
{ fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
if (c1=='-' && c2=='A' && c3=='d' && c4=='o') // probably PS
{ fin.get(c1); fin.get(c2); fin.get(c3);
if (c1=='b' && c2=='e' && c3=='-') ft='3'; } }
if ((c1=='1' || c1=='2') && c2==190 && c3==0 && c4==0) ft='4'; // WRI
else if (c1==255 && c2=='W' && c3=='P' && c4=='C')
{ fin.seekg (8l); fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
if (c1==1 && c2==10 && c3==0 && c4==1) ft='5'; // WP5
if (c1==1 && c2==10 && c3==2 && (c4==0 || c4==1)) ft='6'; } // WP6
else if (c1==29 && c2==125 && c3==0 && c4==0) ft='7'; // WS7
else if (c1=='<' && c2=='H' && c3=='T' && c4=='M')
{ fin.get(c1); fin.get(c2); if (c1=='L' && c2=='>') ft='8'; } // HTML
fin.close (); return ft; }
/***/int get1line (char *buf, int n, int t)
{ static ifstream fin; static char hold[MAXPATH]; static int nh;
int a;
if (!n) { hold[nh=0]=0; fin.open (buf);
if (fin.good()) return 1; return 0; }
if (fin.eof())
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0;
if (t) hold[nh]=html8get(&fin); else fin.get(hold[nh]);
if (hold[nh]=='\r') hold[nh]='\n';
if (fin.eof() || hold[nh]=='\n') break; // end of text
 nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/int get2line (char *buf, int n, int t)
{ static ifstream fin; static char hold[MAXPATH]; static int nh;
int a;
if (!n) { hold[nh=0]=0; fin.open (buf, ios::binary);
if (fin.good()) return 1; return 0; }
if (fin.eof())
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0;
if (t) hold[nh]=ws7get(&fin); else fin.get(hold[nh]);
if (fin.eof()) break;
if (hold[nh]>32 && hold[nh]<127) { nh++; continue; }
hold[nh]=32; if (!nh) nh++; if (hold[nh-1]>32) nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/int get3line (char *buf, int n)
{ static ifstream fin; static char hold[MAXPATH], test[24];
static int nh, s1, skip1, skip2;
int a, b1, b2, s2;
if (!n) { hold[nh=0]=0; s1=0; skip1=1; skip2=0;
fin.open (buf, ios::binary); if (fin.good()) return 1; return 0; }
if (fin.eof())
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0; fin.get(hold[nh]);
if (fin.eof()) break;
if (skip2) { if (hold[nh]=='\n') skip2=0; else continue; }
if (s1<9) switch (s1) { case 0: if (hold[nh]=='\n') s1++; break;
case 1: if (hold[nh]=='%') s1++; else if (hold[nh]!='\n') s1=0; break;
case 2: if (hold[nh]=='%') s1++; else { s1=0; skip2=1; } break;
case 3: if (hold[nh]=='B') s1++; else s1=0; break;
case 4: if (hold[nh]=='e') s1++; else s1=0; break;
case 5: if (hold[nh]=='g') s1++; else s1=0; break;
case 6: if (hold[nh]=='i') s1++; else s1=0; break;
case 7: if (hold[nh]=='n') { test[b1=0]=0; s1++; } else s1=0; break;
case 8: test[b1]=hold[nh]; test[b1+1]=0; if (isalpha (hold[nh])) b1++;
else { s1++; b2=s2=0; } break; }
if (s1==9 && s2<7) switch (s2) { case 0: if (hold[nh]=='\n') s2++; break;
case 1: if (hold[nh]=='%') s2++; else if (hold[nh]!='\n') s2=0; break;
case 2: if (hold[nh]=='%') s2++; else { s2=0; skip2=1; } break;
case 3: if (hold[nh]=='E') s2++; else s2=0; break;
case 4: if (hold[nh]=='n') s2++; else s2=0; break;
case 5: if (hold[nh]=='d') s2++; else s2=0; break;
case 6: if (b1==b2) s2++;
else  if (hold[nh]==test[b2]) b2++; break; }
if (s1==9 && s2==7) { s1=hold[nh]=='\n'? 1: 0; continue; }
if (s1) continue;
if (hold[nh]=='(') { skip1=0; continue; }
if (hold[nh]==')') { skip1=1; continue; }
if (hold[nh]=='\\') { fin.get(hold[nh]);
if ('0'<=hold[nh] && hold[nh]<='7')
{ int v=hold[nh]&7; fin.get(hold[nh]);
if ('0'<=hold[nh] && hold[nh]<='7')
{ v<<=3; v+=hold[nh]&7; fin.get(hold[nh]);
if ('0'<=hold[nh] && hold[nh]<='7') { v<<=3; v+=hold[nh]&7;
if (v==211) hold[nh]='"'; else if (v==208) hold[nh]='*';
else hold[nh]=v; } } } }

if (skip1) hold[nh]=32;
if (hold[nh]>32 && hold[nh]<127) { nh++; continue; }
hold[nh]=32; if (!nh) nh++; if (hold[nh-1]>32) nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/int get4line (char *buf, int n)
{ static ifstream fin; static char hold[MAXPATH]; static int nh;
static long p1, p2; // starting, ending offsets
int a;
if (!n) { hold[nh=0]=0; fin.open (buf, ios::binary);
if (fin.good()) { unsigned char c1, c2, c3, c4; fin.seekg (14l);
fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
p2=c4; p2<<=8; p2+=c3; p2<<=8; p2+=c2; p2<<=8; p2+=c1;
fin.seekg (p1=128l); return 1; } return 0; }
if (p1==p2) // finished
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0; fin.get(hold[nh]);
if (hold[nh]==char(228)) { unsigned char c1, c2, c3, c4; long p0;
fin.seekg (p1+16); fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
p0=c4; p0<<=8; p0+=c3; p0<<=8; p0+=c2; p0<<=8; p0+=c1; p0+=40;
p1+=p0; fin.seekg(p1); continue; } // skipping a graphic
if (++p1>=p2 || hold[nh]==10) break; // end of readable text
if (hold[nh]>32 && hold[nh]<127) { nh++; continue; }
hold[nh]=32; if (!nh) nh++; if (hold[nh-1]>32) nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/int get5line (char *buf, int n)
{ static ifstream fin; static char hold[MAXPATH]; static int nh;
long p1; int a;
if (!n) { hold[nh=0]=0; fin.open (buf, ios::binary);
if (fin.good()) { unsigned char c1, c2, c3, c4; fin.seekg (4l);
fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
p1=c4; p1<<=8; p1+=c3; p1<<=8; p1+=c2; p1<<=8; p1+=c1;
fin.seekg (p1); return 1; } return 0; }
if (fin.eof())
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0; hold[nh]=wp5get(&fin);
if (fin.eof() || hold[nh]==10) break; // end of text
if (hold[nh]>32 && hold[nh]<127) { nh++; continue; }
hold[nh]=32; if (!nh) nh++; if (hold[nh-1]>32) nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/int get6line (char *buf, int n)
{ static ifstream fin; static char hold[MAXPATH]; static int nh;
long p1; int a;
if (!n) { hold[nh=0]=0; fin.open (buf, ios::binary);
if (fin.good()) { unsigned char c1, c2, c3, c4; fin.seekg (4l);
fin.get(c1); fin.get(c2); fin.get(c3); fin.get(c4);
p1=c4; p1<<=8; p1+=c3; p1<<=8; p1+=c2; p1<<=8; p1+=c1;
fin.seekg (p1); return 1; } return 0; }
if (fin.eof())
{ if (nh) { strcpy (buf, hold); hold[nh=0]=0; return 1; }
fin.close(); return 0; }
while (nh<(MAXPATH-1)) { hold[nh+1]=0; hold[nh]=wp6get(&fin);
if (fin.eof() || hold[nh]==10) break; // end of text
if (hold[nh]>32 && hold[nh]<127) { nh++; continue; }
hold[nh]=32; if (!nh) nh++; if (hold[nh-1]>32) nh++; }
a=nh; if (nh==(MAXPATH-1)) while (--a) // consider word wrap
if (hold[a]==32) { hold[a]=0; a++; break; }
strcpy (buf, hold); if (a && a<nh) { strcpy (hold, hold+a); nh-=a; }
else hold[nh=0]=0; return 1; }
/***/void savetext (line *r, int a1, int a2, char *fn)
{ ofstream fout (fn);
if (fout.fail()) { cprintf ("Cannot create %s", fn); return; }
int a;
if (a1>a2) { a=a1; a1=a2; a2=a; }
for (a=1; r!=NULL; r=r->n, a++)
{ if (a1 && (a<a1 || a>a2)) continue;
if (r->t!=NULL) fout << r->t << endl; }
cprintf ("Write successful."); }
/***/char wp5get (ifstream *fin)
{ unsigned char c1, c2, c3;
long l1;
do { fin->get(c1);
if (fin->eof() || c1==11 || c1==12 || c1==13 || c1==140) c1=10;
if (c1<192) return c1;
else if (c1<208) { switch (c1) {
case 192: l1=3; break;
case 193: l1=8; break;
case 194: l1=10; break;
case 195: case 196: l1=2; break;
case 197: l1=4; break;
case 198: l1=5; break;
case 199: l1=6; break;
case 200: case 201: case 202: case 203: case 204: case 205:
case 206: case 207: l1=0; break; }
fin->seekg (l1, ios::cur); c1=32; }
else { fin->get(c1); fin->get(c2); fin->get(c3);
l1=c3; l1<<=8; l1+=c2;
fin->seekg (l1, ios::cur); c1=32; } }
while (!c1); return c1; }
/***/char wp6get (ifstream *fin)
{ unsigned char c1, c2, c3;
long l;
do { fin->get(c1);
if (fin->eof() || c1==204 || c1==207) c1=10;
if (c1==132) c1='-';
if (c1<192) return c1;
else { switch (c1) {
case 208: case 209: case 210: case 211: case 212: case 213:
case 214: case 221: case 223: case 224: case 226:
fin->seekg (1l, ios::cur); fin->get(c2); fin->get(c3);
l=c3; l<<=8; l+=c2; l-=4;
c1=(c1==208? 10: c1==224? 32: 0); break;
case 240: c1=32; l=3; break;
case 241: c1=32; l=4; break;
case 242: c1=32; l=2; break;
case 243: c1=32; l=2; break;
default: c1='~'; l=0; break; }
fin->seekg (l, ios::cur); } }
while (!c1); return c1; }
/***/char ws7get (ifstream *fin)
{ unsigned char c1, c2, c3;
long l;
fin->get (c1);
if (fin->eof() || c1==13 || c1==138 || c1==141) c1=10;
if (c1==29) { fin->get (c2); fin->get (c3);
l=c3; l<<=8; l+=c2;
fin->seekg (l, ios::cur); }
return c1; }
/***/char html8get (ifstream *fin)
{ unsigned char c1;
fin->get (c1); if (fin->eof()) c1='\n';
while (c1=='<') { do { fin->get(c1); } while (c1!='>');
fin->get(c1); if (fin->eof()) c1='\n'; }
return c1; }
/***/void gethistory (char ft, char *fn, char *hf, history *h)
{ int a, b; ffblk ff;
history t;
for (a=0; a<hst_size; a++) { h[a].ft='?'; h[a].fn[0]=0;
h[a].time=0; h[a].date=0; h[a].size=0;
h[a].start=0; h[a].x=0; h[a].y=0; }
if (findfirst (fn, &ff, 0)) return;
h[0].ft=ft; strcpy (h[0].fn, ff.ff_name);
h[0].date=ff.ff_fdate; h[0].time=ff.ff_ftime; h[0].size=ff.ff_fsize;
h[0].start=0; h[0].x=1; h[0].y=1;
ifstream fin (hf, ios::binary); if (fin.fail()) return; // no history file
for (a=0, b=0; a<hst_size; a++)
{ fin.read ((char *) &t, sizeof(history)); if (fin.eof()) break;
if (ft==t.ft && !strcmp (ff.ff_name, t.fn) && ff.ff_fdate==t.date &&
 ff.ff_ftime==t.time && ff.ff_fsize==t.size) h[0]=t;
else if (++b<hst_size) h[b]=t; } }
