// profile.c -- file analyzer
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
void main (int argc, char **argv)
{ FILE *fp;
int a, c0, c1, c2, flag1, flag2, n;
unsigned ngc, nc1, nc2, ncr, nlf, ncrlf, nff, ncc, ncz, nbs1, nbs2;
long f1[256], f2[256];
for (a=0; a<256; a++) f1[a]=f2[a]=0l;
flag1=flag2=0;
while (argc>1 && (argv[1][0]=='-' || argv[1][0]=='/') &&
 (argv[1][1]=='f' || argv[1][1]=='F'))
{ if (argv[1][2]=='1') flag1=1; if (argv[1][2]=='2') flag2=1;
argc--; argv++; }
if (argc!=2)
{ puts ("Analyzes a file for readability and suggests fixes.");
puts("Usage: PROFILE [options] filename");
puts ("Options: /F1 = ASCII values, /F2 = line lengths."); exit(1); }
if ((fp=fopen(argv[1], "rb"))==NULL)
{ printf ("File %s not found", argv[1]); exit(1); }
ngc=nc1=nc2=ncr=nlf=ncrlf=nff=ncc=ncz=nbs1=nbs2=0;
n=0; c1=0; c2=getc(fp);
do { c0=c1; c1=c2; c2=getc(fp);
nc1++; f1[c1]++; if (c1>127) ngc++;
if (c1=='\b' && c0==c2) nbs1++;
else if (c1=='\b' && (c0=='_' || c2=='_')) nbs2++;
else if (c1=='\f') nff++; else if (c1==26) ncz++;
else if (c1<32 && c1!='\r' && c1!='\n') ncc++;
if (c1=='\r' && c2=='\n')
{ ncrlf++; n++; if (nc1>nc2) { nc2=nc1; a=n; }
if (nc1<255) f2[nc1]++; else f2[255]++; nc1=0; }
else { if (c1=='\r') { ncr++;  n++; if (nc1>nc2) { nc2=nc1; a=n; }
if (nc1<255) f2[nc1]++; else f2[255]++; nc1=0; }
if (c2=='\n') { nlf++; n++; if (nc1>nc2) { nc2=nc1; a=n; }
if (nc1<255) f2[nc1]++; else f2[255]++; nc1=0; }
 } } while (c2!=EOF);
printf ("The file contains %d lines.\n", n);
printf ("It has %d graphics chars and %d FormFeeds.\n", ngc, nff);
printf ("It has %d backspaces", nbs1+nbs2);
if (nbs1 | nbs2) printf (": overwrite=%d, underscore=%d", nbs1, nbs2);
puts (".");
printf ("It has %d control Z and %d other control chars.\n", ncz, ncc);
printf ("%d lines end with CR only.\n", ncr);
printf ("%d lines end with LF only.\n", nlf);
printf ("%d lines end with CRLF together.\n", ncrlf);
printf ("The longest line is #%d with %d chars.\n", a, nc2);
if (ncz>1) { puts ("This is not a recognizable text file.");
if (ncr || nlf) puts ("Do not try running the CRLF program on it.");
puts ("If Barb calls it TXT, try forcing BIN with the /f2 switch."); }
else { if (ncr && !nlf) puts ("The file might be a MACintosh text file.");
else if (!ncr && nlf) puts ("The file might be a UNIX text file.");
if (nbs1 || nbs2 || nlf || ncr)
puts ("Try running the CRLF program on it."); }
if (flag1) { puts ("Frequencies of ASCII values:");
for (a=0; a<256; a++) if (f1[a]) printf ("A=%d, F=%ld\n", a, f1[a]); }
if (flag2) { puts ("Frequencies of line lengths:");
for (a=0; a<255; a++) if (f2[a]) printf ("L=%d, F=%ld\n", a, f2[a]);
if (f2[255]) printf ("L>=255, F=%ld\n", f2[255]); } }
